'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _getHtmlLang = require('./../dom/getHtmlLang');

var _getHtmlLang2 = _interopRequireDefault(_getHtmlLang);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var getLang = function getLang(lang) {
  if (null !== lang) {
    return lang;
  }

  return (0, _getHtmlLang2.default)();
}; /*
    * This file is part of the Front Foundation package.
    *
    * Copyright (c) 2017-present LIN3S <info@lin3s.com>
    *
    * For the full copyright and license information, please view the LICENSE
    * file that was distributed with this source code.
    *
    * @author Beñat Espiña <benatespina@gmail.com>
    */

exports.default = function () {
  var locales = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];
  var lang = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;

  locales.forEach(function (locale) {
    require('parsleyjs/dist/i18n/' + locale + '.js');
  });

  var dividedLang = getLang(lang).split('_');

  var locale = lang;
  if (dividedLang.length > 0) {
    locale = dividedLang[0];
  }

  window.Parsley.setLocale(locale);
};