'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }(); /*
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      * This file is part of the Front Foundation package.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      *
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      * Copyright (c) 2017-present LIN3S <info@lin3s.com>
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      *
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      * For the full copyright and license information, please view the LICENSE
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      * file that was distributed with this source code.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      *
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      * @author Beñat Espiña <benatespina@gmail.com>
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      */

var _jquery = require('jquery');

var _jquery2 = _interopRequireDefault(_jquery);

var _lodash = require('lodash.debounce');

var _lodash2 = _interopRequireDefault(_lodash);

var _lin3sEventBus = require('lin3s-event-bus');

var _dom = require('./../../../../dom');

var _FormSelectInitializedEvent = require('./../../../../event-bus/FormSelect/FormSelectInitializedEvent');

var _FormSelectInitializedEvent2 = _interopRequireDefault(_FormSelectInitializedEvent);

var _FormSelectOptionSelectedEvent = require('./../../../../event-bus/FormSelect/FormSelectOptionSelectedEvent');

var _FormSelectOptionSelectedEvent2 = _interopRequireDefault(_FormSelectOptionSelectedEvent);

var _FormSelectStateChangedEvent = require('./../../../../event-bus/FormSelect/FormSelectStateChangedEvent');

var _FormSelectStateChangedEvent2 = _interopRequireDefault(_FormSelectStateChangedEvent);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var renderSelectOption = function renderSelectOption(optionValue, optionLabel) {
  return '<option value="' + optionValue + '">' + optionLabel + '</option>';
},
    renderSelectOptionView = function renderSelectOptionView(optionValue, optionLabel) {
  return '<div class="form-select__option" data-label="' + optionLabel + '" data-value="' + optionValue + '">' + optionLabel + '</div>';
};

var isMobile = function isMobile(viewportWidth) {
  var mobileBreakpoint = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 1024;
  return viewportWidth < mobileBreakpoint;
};

var FormSelect = function () {
  function FormSelect(domNode) {
    var _this = this;

    _classCallCheck(this, FormSelect);

    this.keyboardControlledSelectedOptionIndex = -1;

    this.domNode = domNode;
    this.$domNode = (0, _jquery2.default)(domNode);
    this.opened = this.$domNode.hasClass('form-select--opened');
    this.focused = false;
    this.enabled = true;

    this.maxHeightDesktop = parseInt(domNode.dataset.maxHeightDesktop, 10);
    this.maxHeightMobile = parseInt(domNode.dataset.maxHeightMobile, 10);
    this.isFilterable = parseInt(domNode.dataset.filterable, 10) === 1;
    this.filterBy = domNode.dataset.filterOrderBy;
    this.mobileBreakpoint = parseInt(domNode.dataset.mobileBreakpoint, 10);
    this.mouseOverListenerEnabled = true;

    if (this.isFilterable) {
      this.$filterInput = this.$domNode.find('.form-select__input');
    }

    this.$select = this.$domNode.find('.form-select__select');
    this.$selectOptionsContainer = this.$domNode.find('.form-select__options-container');
    this.$selectOptions = this.$domNode.find('.form-select__options');
    this.$selectLabel = this.$domNode.find('.form-select__label');

    this.debouncedFilter = (0, _lodash2.default)(function () {
      return _this.filter();
    }, 500);

    this.needsParsleyValidation = this.$domNode.parents('form[data-parsley-validate]').length > 0;

    this.addParsleyValidator();
    this.parseSelectOptions();
    this.bindListeners();
    this.setSelectOpened(this.opened);
    this.setInitiallySelectedOption();

    this.publishFormSelectInitializedEvent();
  }

  _createClass(FormSelect, [{
    key: 'addParsleyValidator',
    value: function addParsleyValidator() {
      var validatorName = 'notDefaultOption';

      if (window.Parsley.hasValidator(validatorName)) {
        return;
      }

      var noSelectionValue = this.$domNode.find('.form-select__select-no-selection').val();

      window.Parsley.addValidator(validatorName, {
        validateString: function validateString(value) {
          return value !== noSelectionValue;
        },
        messages: {
          en: 'The selected option is the default one',
          es: 'La opción seleccionada es la opción por defecto',
          eu: 'Hautatutako aukera lehenetsiko aukera da'
        }
      });
    }
  }, {
    key: 'parseSelectOptions',
    value: function parseSelectOptions() {
      var $selectOptions = this.$select.find('option');
      this.options = Array.from($selectOptions).map(function (selectOption) {
        var $selectOption = (0, _jquery2.default)(selectOption);
        return {
          value: $selectOption.val().trim(),
          label: $selectOption.text().trim()
        };
      });
    }
  }, {
    key: 'getOptionsContainerNeedsOverflow',
    value: function getOptionsContainerNeedsOverflow(optionsContainerHeight) {
      return isMobile(this.windowWidth, this.mobileBreakpoint) && optionsContainerHeight >= this.maxHeightMobile || !isMobile(this.windowWidth, this.mobileBreakpoint) && optionsContainerHeight >= this.maxHeightDesktop;
    }
  }, {
    key: 'setOptionsContainerHeight',
    value: function setOptionsContainerHeight(height) {
      // Prevent overflow/scroll animation
      this.$selectOptionsContainer.toggleClass('form-select__options-container--no-overflow', !this.getOptionsContainerNeedsOverflow(height));

      this.$selectOptionsContainer.height(height);
    }
  }, {
    key: 'getOptionsContainerHeight',
    value: function getOptionsContainerHeight() {
      var totalHeight = Array.from(this.$domNode.find('.form-select__option')).reduce(function (accumulatedHeight, option) {
        return accumulatedHeight + (0, _jquery2.default)(option).outerHeight();
      }, 0);

      if (isMobile(this.windowWidth, this.mobileBreakpoint) && totalHeight >= this.maxHeightMobile) {
        return this.maxHeightMobile;
      } else if (!isMobile(this.windowWidth, this.mobileBreakpoint) && totalHeight >= this.maxHeightDesktop) {
        return this.maxHeightDesktop;
      }

      return totalHeight;
    }
  }, {
    key: 'bindListeners',
    value: function bindListeners() {
      var _this2 = this;

      if (this.isFilterable) {
        this.$filterInput.on('input.form_select', function () {
          _this2.debouncedFilter();
        });

        this.$filterInput.on('click.form_select', function (event) {
          if (_this2.opened) {
            event.stopPropagation();
          }
        });
      }

      (0, _jquery2.default)(window).on('click.form_select', this.close.bind(this));

      this.$domNode.on('focus.form_select', function () {
        return _this2.setSelectFocused(true);
      });

      this.$domNode.on('click.form_select', function (event) {
        event.stopPropagation();

        _this2.setSelectOpened(!_this2.opened);
      });

      this.$domNode.on('click.form_select_option', '.form-select__option', function (event) {
        _this2.setSelectedOption((0, _jquery2.default)(event.currentTarget));
      });

      this.$domNode.on('mouseover.form_select_option', '.form-select__option', function (event) {
        if (!_this2.mouseOverListenerEnabled) {
          return;
        }

        _this2.setKeyboardControlledSelectedOptionView(_this2.$domNode.find('.form-select__option'), (0, _jquery2.default)(event.currentTarget));
        _this2.keyboardControlledSelectedOptionIndex = (0, _jquery2.default)(event.currentTarget).index();
      });

      this.$domNode.on('mousemove.form_select_option', '.form-select__option', function () {
        _this2.mouseOverListenerEnabled = true;
      });

      this.$domNode.on('keydown.form_select', function (event) {
        if (!(event.which === 40 || event.which === 38 || event.which === 13 || event.which === 9)) {
          return;
        }

        if (!_this2.opened && _this2.focused && event.which === 13) {
          _this2.open();
          return;
        } else if (event.which === 9) {
          _this2.close();
          return;
        }

        event.preventDefault();
        _this2.mouseOverListenerEnabled = false;

        var $selectOptionViews = _this2.$domNode.find('.form-select__option');

        if (event.which === 40) {
          // down
          _this2.keyboardControlledSelectedOptionIndex = _this2.keyboardControlledSelectedOptionIndex < $selectOptionViews.length - 1 ? _this2.keyboardControlledSelectedOptionIndex + 1 : $selectOptionViews.length - 1;
          _this2.setKeyboardControlledSelectedOptionView($selectOptionViews, $selectOptionViews.eq(_this2.keyboardControlledSelectedOptionIndex), true);
        } else if (event.which === 38) {
          // up
          _this2.keyboardControlledSelectedOptionIndex = _this2.keyboardControlledSelectedOptionIndex > 0 ? _this2.keyboardControlledSelectedOptionIndex - 1 : 0;
          _this2.setKeyboardControlledSelectedOptionView($selectOptionViews, $selectOptionViews.eq(_this2.keyboardControlledSelectedOptionIndex), true);
        } else if (event.which === 13) {
          // enter
          _this2.setSelectedOption($selectOptionViews.eq(_this2.keyboardControlledSelectedOptionIndex));
          _this2.close();
        }
      });

      (0, _lin3sEventBus.onWindowResized)(this.onResize.bind(this));
    }
  }, {
    key: 'onResize',
    value: function onResize(windowResizedEvent) {
      this.windowWidth = windowResizedEvent.windowWidth || (0, _jquery2.default)(window).width();

      if (this.opened) {
        this.open();
      }
    }
  }, {
    key: 'setInitiallySelectedOption',
    value: function setInitiallySelectedOption() {
      var $selectedOption = this.$select.find('option[selected="selected"]');

      if ($selectedOption.length === 0) {
        return;
      }

      this.onOptionSelected($selectedOption.text(), $selectedOption.val());
    }
  }, {
    key: 'setSelectOpened',
    value: function setSelectOpened(opened) {
      if (opened) {
        this.open();
      } else {
        this.close();
      }

      this.publishFormSelectStateChangedEvent(opened ? FormSelect.STATE.OPENED : FormSelect.STATE.CLOSED);
    }
  }, {
    key: 'setSelectFocused',
    value: function setSelectFocused(focused) {
      this.focused = focused;
      this.$domNode.toggleClass('form-select--focused', focused);
    }
  }, {
    key: 'open',
    value: function open() {
      if (!this.enabled) {
        return;
      }

      this.$domNode.addClass('form-select--opened');
      this.$domNode.addClass('form-select--editing-input', this.isFilterable);
      this.setOptionsContainerHeight(this.getOptionsContainerHeight());
      this.opened = true;
      this.setSelectFocused(false);

      if (this.isFilterable) {
        this.$filterInput.focus();
      }
    }
  }, {
    key: 'close',
    value: function close() {
      if (!this.enabled) {
        return;
      }

      this.$domNode.removeClass('form-select--opened');
      this.$domNode.removeClass('form-select--editing-input');
      this.setOptionsContainerHeight(0);
      this.opened = false;
      this.setSelectFocused(false);

      if (this.isFilterable) {
        this.$filterInput.blur();
      }
    }
  }, {
    key: 'onOptionSelected',
    value: function onOptionSelected(optionLabel, optionValue) {
      var publishEvent = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : true;

      if (!this.enabled) {
        return;
      }

      // Explicitly cast to String
      var label = String(optionLabel),
          value = String(optionValue);

      if (this.selectedOptionLabel === optionLabel || this.selectedOptionValue === optionValue) {
        return;
      }

      this.setSelectValue(value);
      this.setSelectLabelValue(label);
      this.setSelectActiveOption(value);

      this.selectedOptionLabel = optionLabel;
      this.selectedOptionValue = optionValue;

      if (this.needsParsleyValidation) {
        this.$select.parsley().validate();
      }

      if ((this.selectedOptionLabel !== undefined || this.selectedOptionValue !== undefined) && publishEvent) {
        this.publishFormSelectOptionSelectedEvent(value);
      }
    }
  }, {
    key: 'setSelectValue',
    value: function setSelectValue(value) {
      this.$select.val(value);
    }
  }, {
    key: 'setSelectLabelValue',
    value: function setSelectLabelValue(value) {
      this.$selectLabel.html(value);
    }
  }, {
    key: 'setSelectActiveOption',
    value: function setSelectActiveOption(optionValue) {
      Array.from(this.$domNode.find('.form-select__option')).forEach(function (selectOption) {
        var $selectOption = (0, _jquery2.default)(selectOption),
            selectOptionValue = $selectOption.data('value');
        $selectOption.toggleClass('form-select__option--active', String(selectOptionValue) === String(optionValue));
      });
    }
  }, {
    key: 'setSelectedOptionByOptionValue',
    value: function setSelectedOptionByOptionValue(optionValue) {
      var $option = this.$domNode.find('.form-select__option[data-value="' + optionValue + '"]'),
          label = $option.attr('data-label');
      this.onOptionSelected(label, optionValue, false);
    }
  }, {
    key: 'update',
    value: function update() {
      var _ref = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
          options = _ref.options,
          _ref$publishEvent = _ref.publishEvent,
          publishEvent = _ref$publishEvent === undefined ? true : _ref$publishEvent;

      this.close();
      this.destroy();

      if (options.length === 0) {
        return;
      }

      this.build(options);
      this.setSelectedOptionDefault(publishEvent);
    }
  }, {
    key: 'destroy',
    value: function destroy() {
      this.$selectOptions.find('.form-select__option').not('.form-select__option--select-no-selection').remove();
      this.$select.find('option').not('.form-select__select-no-selection').remove();
      this.$filterInput.val('');
    }
  }, {
    key: 'build',
    value: function build(options) {
      var _this3 = this;

      this.options = options;
      this.options.forEach(function (option) {
        _this3.$select.append(renderSelectOption(option.value, option.label));
        _this3.$selectOptions.append(renderSelectOptionView(option.value, option.label));
      });
      this.setOptionsContainerHeight(this.getOptionsContainerHeight());
    }
  }, {
    key: 'filter',
    value: function filter() {
      var _this4 = this;

      var noSelectionValue = this.$domNode.find('.form-select__select-no-selection').val();
      var filterValue = this.$filterInput.val();
      var filteredOptions = this.options.filter(function (option) {
        return option.label.toLowerCase().includes(filterValue.toLowerCase()) || filterValue === '' || option.value === noSelectionValue;
      });

      // Remove unnecessary ones
      this.options.forEach(function (option) {
        if (filteredOptions.indexOf(option) === -1) {
          var $option = _this4.$selectOptions.find('[data-value="' + option.value + '"]');
          $option.remove();
        }
      });

      // Add necessary ones
      filteredOptions.forEach(function (filteredOption) {
        var $selectOption = _this4.$domNode.find('.form-select__option[data-value="' + filteredOption.value + '"]');

        if ($selectOption.length === 0) {
          // Find place to inject
          var $currentSelectOptionViews = _this4.$domNode.find('.form-select__option:not(:first)'),
              newSelectOption = renderSelectOption(filteredOption.value, filteredOption.label),
              newSelectOptionView = renderSelectOptionView(filteredOption.value, filteredOption.label);
          var found = false,
              index = 0;

          while (index < $currentSelectOptionViews.length && !found) {
            var $currentSelectOption = (0, _jquery2.default)($currentSelectOptionViews[index]);

            var isInteger = !isNaN(parseInt($currentSelectOption.data('' + _this4.filterBy), 10)) && !isNaN(parseInt(filteredOption['' + _this4.filterBy], 10));

            var currentOptionIsBiggerThanFilteredOne = isInteger ? parseInt($currentSelectOption.data('' + _this4.filterBy), 10) > parseInt(filteredOption['' + _this4.filterBy], 10) // eslint-disable-line max-len
            : String($currentSelectOption.data('' + _this4.filterBy)).trim().localeCompare(filteredOption['' + _this4.filterBy], (0, _dom.getHtmlLang)(), { sensitivity: 'base' }) > 0; // eslint-disable-line max-len

            if (currentOptionIsBiggerThanFilteredOne) {
              found = true;
            }

            index++;
          }

          if (found) {
            _this4.$select.find('option').eq(index).before(newSelectOption);
            _this4.$domNode.find('.form-select__option').eq(index).before(newSelectOptionView);
          } else {
            _this4.$select.append(newSelectOption);
            _this4.$selectOptions.append(newSelectOptionView);
          }
        }
      });

      this.setOptionsContainerHeight(this.getOptionsContainerHeight());

      // select none
      this.setSelectedOptionDefault(false);
    }
  }, {
    key: 'setSelectedOptionDefault',
    value: function setSelectedOptionDefault() {
      var publishEvent = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : true;

      var $noSelection = this.$domNode.find('.form-select__select-no-selection');
      this.onOptionSelected($noSelection.text().trim(), $noSelection.val().trim(), publishEvent);
    }
  }, {
    key: 'setSelectedOption',
    value: function setSelectedOption($option) {
      this.onOptionSelected($option.data('label'), $option.data('value'));
    }
  }, {
    key: 'setKeyboardControlledSelectedOptionView',
    value: function setKeyboardControlledSelectedOptionView($selectOptionViews, $optionView) {
      var animateScroll = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : false;

      $selectOptionViews.removeClass('form-select__option--hover');

      if ($optionView === undefined) {
        return;
      }

      $optionView.addClass('form-select__option--hover');

      // Scroll to option
      if (!animateScroll) {
        return;
      }

      $optionView[0].scrollIntoView({ behaviour: 'smooth' });
    }
  }, {
    key: 'enable',
    value: function enable() {
      this.enabled = true;
    }
  }, {
    key: 'disable',
    value: function disable() {
      this.enabled = false;
    }
  }, {
    key: 'publishFormSelectInitializedEvent',
    value: function publishFormSelectInitializedEvent() {
      _lin3sEventBus.OneTimeEventPublisher.publish(new _FormSelectInitializedEvent2.default(this));
    }
  }, {
    key: 'publishFormSelectOptionSelectedEvent',
    value: function publishFormSelectOptionSelectedEvent(value) {
      _lin3sEventBus.LifeTimeEventPublisher.publish(new _FormSelectOptionSelectedEvent2.default(this, value));
    }
  }, {
    key: 'publishFormSelectStateChangedEvent',
    value: function publishFormSelectStateChangedEvent(state) {
      _lin3sEventBus.LifeTimeEventPublisher.publish(new _FormSelectStateChangedEvent2.default(this, state));
    }
  }]);

  return FormSelect;
}();

FormSelect.STATE = {
  OPENED: 'OPENED',
  CLOSED: 'CLOSED'
};
exports.default = FormSelect;